-- CodeaAI

-- Use cases:
--  Complex animations with no keyframes.
--  More...

local pos = vec2(math.random(0, WIDTH), math.random(0, HEIGHT))
local target = vec2(0.5, 0.5)

local m
    
function setup()
    m = AI.Model.load(asset.models.finger_chase, true)
    --m = Model(4, {4, 2})

    --local loss = m:train(genDataSet(10000), 0.0001, 100)
    --print("Final loss: " .. loss)
    
    
    --m:save(asset.documents .. "model.json")
end

function draw()
    -- Update pos
    local v = m({pos.x / WIDTH, pos.y / HEIGHT, target.x, target.y})
    v = vec2(v[1] * WIDTH, v[2] * HEIGHT) * 1.2 * DeltaTime
    pos = pos + v
    
    -- Draw circle
    background(0)
    fill(0,192,0)
    ellipseMode(CENTER)
    ellipse(pos.x, pos.y, 30)
    
    text(math.floor(1 / DeltaTime), WIDTH-20, 20)
end
    
function touched(touch)
    target = vec2(touch.pos.x/WIDTH, touch.pos.y/HEIGHT)
end
    
